      **************************************************************
      ******Printctl procedure file, By Henry J. Franzoni III*******
      ******Controls Output Selection on Novell 286 Network. *******
      ******       Released into public domain 9/28/87.      *******
      **************************************************************
DO PRINTCTL
DO TESTLOOP
PROCEDURE PRINTCTL                 && Initialize, variables then run OUTPUT
SET SCOREBOARD OFF
SET CONFIRM OFF
SET SAFETY OFF
SET TALK OFF
SET UNIQ OFF
SET EXCL OFF
SET STATUS OFF
SET MENU OFF
SET BELL OFF
*
********************* Declarations for memory variables********************
*
PUBL CLIPPER,MSCOLO,OUTPUT,DUMMY1,DUMMY2,DUMMY3
PUBL USER,STA,ENLGON,ENLGOFF,SPLVAR,PRINTVAR,PAUSE
PUBL L1QON,L1QOFF,G1RAPHON,G1RAPHOFF,E1LITEON,E1LITEOFF,C1OMPRON,C1OMPROFF
PUBL LQON,LQOFF,GRAPHON,GRAPHOFF,ELITEON,ELITEOFF,COMPRON,COMPROFF,FRAME
*
**************************Get Station number, user name****************
*
USER=GETE("USER")                  && Used for Q command user delete option
STA=GETE("STA")                    && Used for unique file name creation.
*STA=LTRIM(STR(STATION(),4,0))     && You could use this method instead for
*                                  && STA with Clipper and an assembler
*
**************************Determine monitor attributes*****************
*
IF CLIPPER                         && Clipper uses more video parameters
    MSCOLO=IIF (ISCOLOR(), 'GR+/B,W+/R,N+,,R/W','N/W,W/N,N,,I')
  ELSE
    MSCOLO=IIF (ISCOLOR(), 'GR+/B,W+/R,N+','N/W,W/N,N')
  ENDI
SET COLO TO &MSCOLO
CLEA
DO OUTPUT WITH DUMMY1,DUMMY2,DUMMY3
RETURN                             && End of Printctl procedure
*
***********************************************************************
PROC TESTLOOP
AGAIN=" "                          && Test loop for Clipper version
DO WHIL AGAIN # "E"
  DO ASK2 WITH 23,0,"(P)rintctl, (O)utput, o(N), of(F), form fee(D), (E)xit ","PONFDE",AGAIN
  DO CASE
    CASE AGAIN="P"                 && This enables Clipper users to
      DO PRINTCTL                  && try each procedure.
    CASE AGAIN="O"
      DO OUTPUT WITH 1,2,3         && Dummy parameters
    CASE AGAIN="N"
      DO PRINTON
    CASE AGAIN="F"
      DO PRINTOFF
    CASE AGAIN="D"
      DO FORMFEED
  ENDC
ENDD                               && End of test loop
RETU
********************************************************************
PROCEDURE OUTPUT
PARA W,X,Y  && dummy parameters enable hot-key access, if desired.
*           DO OUTPUT WITH DUMMY1,DUMMY2,DUMMY3 in Dbase or Clipper
*           SET KEY 301 TO OUTPUT For Clipper Alt-X hot-key only.
*           Determines where output is going: Disk, Printer, Screen,
*           Or Novell Network printers connected to the current file server
*           Assumes a public character variable called OUTPUT for other
*           releated procedures such as PrintOn, PrintOff, and Printset
*
DO ASK2 WITH 22,0,"(P)rinter, (S)creen, (N)etwork, (D)isk ","PNDS",OUTPUT
OUTPUT=UPPE(OUTPUT)
@ 23,0 CLEA
IF CLIPPER                         && Clipper code first
  DO CASE
    CASE OUTPUT='P'                && Printer chosen
    SET PRINTER TO LPT1
  CASE OUTPUT='S'                  && Screen chosen
    Pause=.F.
    @ 23,0 SAY 'Pause for each page (Y/N)? ' GET Pause
    READ
  CASE OUTPUT='D'                  && Disk file chosen
    OUTPUT='D'
    File=space(20)
    @ 23,0 SAY "Enter drive/directory/file name: " GET FILE PICT "@!"
    READ
      IF ! EMPTY(File)
        SET PRINTER TO &File
      ELSE
        OUTPUT='S'                 && Default screen if no disk file
      ENDIF
  CASE OUTPUT='N'                  && Network printers chosen
    SET PRINTER TO LPT1
    DO PRINTSET WITH 20,0
  ENDC
ELSE                               && Dbase III+ code next
  DO CASE
    CASE OUTPUT='P'                && Printer
    SET PRINTER TO
  CASE OUTPUT='S'                  && Screen
    Pause=.F.
    @ 23,0 SAY 'Pause for each page (Y/N)? ' GET Pause
    READ
  CASE OUTPUT='D'                  && Disk
    OUTPUT='D'
    File=space(20)
@ 23,0 SAY "Enter drive/directory/file name: " GET FILE PICT "@!"
    READ
      IF File # " "
        SET ALTERNATE TO &File
      ELSE
        OUTPUT='S'
      ENDIF
  CASE OUTPUT='N'                  && Network printers
    SET PRINTER TO
    DO PRINTSET WITH 20,0
  ENDC
ENDI
RETU
*****************************************************************
PROCEDURE PRINTON                  && Turns output on
* Syntax:   DO PRINTON
*           Do this procedure after doing OUTPUT, instead of using
*           SET PRINT ON or SET DEVICE TO PRINT in your application.
*
IF TYPE('OUTPUT') = 'U'             && If Output undefined
  PUBLIC OUTPUT
  OUTPUT='S'
ENDIF
IF TYPE('OUTPUT') # 'C'             && If Output isn't a character string
  OUTPUT='S'
ENDIF
SET PRINT OFF
SET CONSOLE OFF
SET ALTERNATE OFF
  DO CASE
    CASE OUTPUT$'PN'                && If Output is a Printer or the network
      IF CLIPPER                    && If using clipper?
        IF ISPRINTER()              && Printer ready?
          SET PRINT ON
          SET DEVICE TO PRINT
        ELSE
          ?? chr(7)
          @ 0,0 SAY 'Hit any key when the printer is ready. [Esc] for Screen output.'
          key=inkey(0)
            DO WHILE Key#27 .AND. .NOT. ISPRINTER()
              KEY=INKEY(0)
            ENDDO
          IF Key=27
            SET CONS ON
            OUTPUT='S'
            Pause=.T.
            @ 23,0 SAY 'Pause for each page (Y/N)? ' GET Pause
            READ
            @ 23,0
          ENDIF
            @ 0,0
        ENDIF
      ELSE                          && If using Dbase III+
        SET PRINT ON                && No check like Isprinter()
        SET DEVICE TO PRINT
      ENDI
    CASE OUTPUT='D'                 && If Output is a disk file
        IF .NOT. CLIPPER            && If using Dbase III+
          SET ALTERNATE ON
        ELSE                        && If using Clipper
          SET PRINT ON
          SET DEVICE TO PRINT
        ENDI
    OTHE
      SET CONSOLE ON
    ENDCASE
RETURN
*
PROCEDURE PRINTOFF                && Turns output off
*           Do this procedure after doing procedures OUTPUT and PRINTON
*           Use this instead of SET PRINT OFF and SET DEVICE TO SCREEN
*           in your applications.
*
IF TYPE('OUTPUT') # 'C'
  OUTPUT='S'
ENDIF
IF OUTPUT='S'                     && If output was to the screen
  WAIT
  @ 0,0 CLEA
ELSE                              && If output was anything else
  SET DEVICE TO SCREEN
  SET ALTERNATE OFF
  SET ALTERNATE TO
  SET PRINT OFF
  SET PRINTER TO
  SET CONS ON
ENDIF
IF OUTPUT='N'                     && If output was the network
  @ 22,0 CLEA
  !ENDSPOOL
ENDI
OUTPUT='S'                        && Output defaults to the screen
RETURN
*
PROCEDURE FORMFEED                && Issues appropriate form feed
DO CASE
CASE OUTPUT='S'                   && Output is screen
  IF PAUSE
    DO CNTR WITH 'Hit a key'
    inkey(0)
  ENDIF
  CLEA
CASE OUTPUT = 'D'                 && Output is disk file
  ?? chr(12)
CASE OUTPUT $ 'NP'                && Output is printer or network
  IF CLIPPER
    IF ISPRINTER()
      EJEC
    ENDI
  ELSE
    EJEC
  ENDI
ENDC
RETU
*
PROC PRINTSET                     && network printer control program
PARA RR,CC
DO BLOCKCLR WITH RR,CC
STOR SPAC(10) TO PRINTVAR
STOR " " TO SPLVAR
DO PRNTCODE
  DO WHIL .T.
    DO ASK2 WITH RR,CC,"Printer: (0), (1), (2), (3), (4), (C)ancel, (S)pool, (Q)ueue, (E)xit ","CSQE01234",SPLVAR
      DO CASE
        CASE SPLVAR='S'           && Do Spooler setup
          DO SPOOL WITH RR,CC
        CASE SPLVAR='0'           && Spool printer 0
          @ 20,0 CLEA
          !SPOOL /P0 NB C=1
          EXIT
        CASE SPLVAR='1'           && Spool printer 1
          @ 20,0 CLEA
          !SPOOL /P1 NB C=1
          EXIT
        CASE SPLVAR='2'           && Spool printer 2
          @ 20,0 CLEA
          !SPOOL /P2 NB C=1
          EXIT
        CASE SPLVAR='3'           && Spool printer 3
          @ 20,0 CLEA
          !SPOOL /P3 NB C=1
          EXIT
        CASE SPLVAR='4'           && Spool printer 4
          @ 20,0 CLEA
          !SPOOL /P4 NB C=1
          EXIT
        CASE SPLVAR='Q'           && Setup Q options
          DO QUEUE WITH RR,CC
        CASE SPLVAR='C'           && Cancel jobs with Endspool C or Q /D
          PRIV C1,C2,C3
          STOR " " TO C1
          DO ASK2 WITH RR+1,CC,"Delete (A)vailable jobs or (P)ending spooler job","AP",C1
            IF C1='P'
              @ RR,CC SAY " "
              !ENDSPOOL C         && Cancel current print job
              WAIT
            ELSE
              STOR " " TO C2
              DO ASK2 WITH RR+2,CC,"Select printer queue to delete (0,1,2,3,4)?","01234",C2
                IF CLIPPER
                  SAVE SCREEN
                ENDI
                  @ 0,0 CLEA
              STOR " *.*" TO C3   && Build command string
              STOR C3+" /P"+C2+" " TO C3
              STOR C3+"U="+USER+" " TO C3
              STOR C3+" D" TO C3
              !Q &C3              && Issue built up Q command to DOS
              WAIT
                IF CLIPPER
                  RESTORE SCREEN
                ENDI
            ENDI
        CASE SPLVAR='E'
          EXIT
        ENDC
    ENDD
       @ 0,0 clea
RETU
*
PROC SPOOL                        && Spool command control
PARA RR,CC
PRIV SP1,SP2,SP3,SP4,SP5,SP6,SP7,SP8,SP9,SP10
STOR " " TO SP7
STOR "0" TO SP1,SP2
STOR .F. TO SP3,SP6,SP5,SP9,SP10
STOR SPAC(14) TO SP4
STOR "0  " TO SP8
  DO WHIL .T.
    DO BLOCKCLR WITH RR,CC
    DO ASK2 WITH RR,CC,"Select network printer (0,1,2,3,4) or (E)xit?","01234E",SP1
      IF SP1="E"
        DO BLOCKCLR WITH RR,CC
        RETU
      ENDI
    @ RR,CC SAY "Printer "+SP1+" selected."
    STOR " P"+SP1 TO SP7
    DO ASKL WITH RR+1,CC,"Show spooler settings only?",SP3
      IF SP3
          IF CLIPPER
            SAVE SCREEN
          ENDI
        @ 0,0 CLEA
        STOR SP7+" SH" TO SP7
        !SPOOL &SP7               && Issue spool show command to DOS
        WAIT
        STOR " " TO SP7
        @ 0,0 CLEA
          IF CLIPPER
            RESTORE SCREEN
          ENDI
        RETU
      ENDI
    DO ASK2 WITH RR+1,CC,"Select number of copies 0-9, 0 for disk file only ","0123456789",SP2
      DO CASE
        CASE SP2="1"
          @ RR+1,CC SAY SP2+" copy selected."
        CASE SP2="0"
          @ RR+1,CC SAY "Disk file only"
        OTHE
          @ RR+1,CC SAY SP2+" copies selected."
      ENDC
    DO ASKL WITH RR+2,CC,"Create disk file? (Y/N)",SP3
      IF SP3
        @ RR+2,CC SAY "Enter filename (With drive identifier) for disk file" GET SP4 PICT 'A:AXXXXXXXXXXX'
        READ
        @ RR+2,CC SAY SPAC(80)
        @ RR+2,CC SAY "File name "+SP4+" selected."
      ENDI
    DO ASKL WITH RR+3,CC,"Alter default form type in printer? (Y/N)",SP10
      IF SP10
        @ RR+3,CC SAY "Enter form type 0-255 or <cr> for 0, the default form " GET SP8 PICT '999'
        READ
      ENDI
    DO ASKL WITH RR+4,CC,"Add form feed after printing job (Y/N)?",SP9
    DO ASKL WITH RR+4,CC,"Execute this spooler command (Y/N)?",SP5
      IF SP5
       EXIT
      ENDI
  ENDD
STOR SP7+" NB" TO SP7             && Build spool command
STOR SP7+" C="+TRIM(SP2) TO SP7   && number of copies
STOR SP7+" F="+TRIM(SP8) TO SP7
  IF SP3                          && create a file?
    STOR SP7+" CR="+TRIM(SP4) TO SP7
  ENDI
  IF SP9                          && add form feed?
    STOR SP7+" FF" TO SP7         && Yes add form feed
  ELSE
    STOR SP7+" NFF" TO SP7        && No form feed
  ENDI
DO BLOCKCLR WITH RR,CC
@ RR,CC SAY " "
!SPOOL &SP7                       && Issue spool command to DOS
DO BLOCKCLR WITH RR,CC
DO ASKL WITH RR,CC,"Add extra printer control codes (Y/N)?",SP6
  IF SP6
    DO CTLCODES WITH RR,CC        && Send printer control codes
  ENDI
RETU
*
PROC QUEUE                        && Q command control
PARA RR,CC
PRIV Q1,Q2,Q3,Q4,Q5,Q6,Q7
STOR SPAC(12) TO Q1
STOR USER TO Q5
STOR STA TO Q4
STOR "0" TO Q2
STOR " " TO Q3
STOR .F. TO Q6,Q7,Q8
  DO WHIL .T.
    DO BLOCKCLR WITH RR,CC
    DO ASK2 WITH RR,CC,"Select printer queue number 0,1,2,3,4 or (E)xit?","01234E",Q2
      IF Q2="E"                   && Exit
        DO BLOCKCLR WITH RR,CC
        RETU
      ENDI
    @ RR,CC SAY "Printer queue "+Q2+" selected."
    @ RR+1,CC SAY "Select files: enter <filespec> , print job #, or <cr> for all?" GET Q1 PICT 'XXXXXXXXXXXX'
    READ
    DO ASK2 WITH RR+2,CC,"Select files: (A)ll, (S)tation "+STA+" only, or (U)ser "+USER+" only?","SUA",Q3
      DO CASE
        CASE Q3='S'
          STOR "ST="+Q4 TO Q3
          @ RR+2,CC SAY "Files from station number "+Q4+" selected."
        CASE Q3='U'
          STOR "U="+TRIM(Q5) TO Q3
          @ RR+2,CC SAY "Files from user "+TRIM(Q5)+" selected."
        CASE Q3='A'
          @ RR+2,CC SAY "All available files selected."
          Q3=' '
      ENDC
    DO ASKL WITH RR+4,CC,"Delete these files from the queue (Y/N)?",Q6
    DO ASKL WITH RR+4,CC,"Do you want a detailed file list (Y/N)?",Q7
    DO ASKL WITH RR+4,CC,"Do it all now (Y/N)?",Q8
      IF Q8                       && Execute Q command
        EXIT
      ENDI
  ENDD
  IF Q1 # " "                     && Build Q command
    Q1=" "+TRIM(Q1)+" "
  ELSE
    Q1=" "
  ENDI
    Q1=Q1+"/P="+Q2                && Printer number
  IF Q3 # " "
    Q1=Q1+" "+Q3
  ENDI
  IF Q6
    Q1=Q1+" D"                    && Delete flag?
  ENDI
  IF .NOT. Q7
    Q1=Q1+" NL"                   && No detailed list?
  ENDI
  IF CLIPPER
    SAVE SCREEN
  ENDI
@ 0,0 CLEA
!Q &Q1                            && issue Q command to DOS
WAIT
  IF CLIPPER
    RESTORE SCREEN
  ENDI
DO BLOCKCLR WITH RR,CC
RETU
*
PROC CTLCODES                     && ISSUES CONTROL CODES TO PRINTERS
PARA RR,CC                        && ONLY TWO PRINTERS, ADD MORE YOURSELF...
DO BLOCKCLR WITH RR,CC            && EXTEND THE DO CASE STRUCTURE
VALU='E'                          && Exit
  DO CASE
    CASE SP1="1"                  && Menu for printer 1
    @ RR,CC SAY '(1) Letter quality on                  (2) Letter quality off'
    @ RR+1,CC SAY '(3) Graphic characters on              (4) Graphic characters off'
    @ RR+2,CC SAY '(5) 20 chars. per inch on              (6) 20 chars. per inch off'
      DO WHIL .T.
        @ RR+3,CC SAY '(7) 17 chars. per inch on              (8) 17 chars. off {(E)xit } -> ' GET VALU PICT '@! X'
        READ                      && Get menu choice
          DO CASE
            CASE VALU='1'
              PRINTVAR=L1QON
            CASE VALU='2'
              PRINTVAR=L1QOFF
            CASE VALU='3'
              PRINTVAR=G1RAPHON
            CASE VALU='4'
              PRINTVAR=G1RAPHOFF
            CASE VALU='5'
              PRINTVAR=E1LITEON
            CASE VALU='6'
              PRINTVAR=E1LITEOFF
            CASE VALU='7'
               PRINTVAR=C1OMPRON
            CASE VALU='8'
               PRINTVAR=C1OMPROFF
            CASE VALU='E'
               EXIT
            OTHE
               LOOP
          ENDC
          IF CLIPPER
            IF ISPRINTER()
              SET CONS OFF
              SET PRIN ON
              ?&PRINTVAR          && Send printer control code
              SET PRIN OFF
              SET CONS ON
            ENDI
          ELSE
            SET CONS OFF
            SET PRIN ON
            ?&PRINTVAR            && Send printer control code
            SET PRIN OFF
            SET CONS ON
          ENDI
      ENDD
    CASE SP1='0'                  && Menu for printer 0
      @ RR,CC SAY '(1) Letter quality on                  (2) Letter quality off'
      @ RR+1,CC SAY '(3) 5 chars. per inch on               (4) 5 chars per inch off'
      @ RR+2,CC SAY '(5) 12 chars. per inch on              (6) 12 chars. per inch off'
        DO WHIL .T.
          @ RR+3,CC SAY '(7) 17 chars. per inch on              (8) 17 chars. off {(E)xit } -> ' GET VALU PICT '@! X'
          READ                    && get choice for printer 0
            DO CASE
              CASE VALU='1'
                PRINTVAR=LQON
              CASE VALU='2'
                PRINTVAR=LQOFF
              CASE VALU='3'
                PRINTVAR=ENLGON
              CASE VALU='4'
                PRINTVAR=ENLGOFF
              CASE VALU='5'
                PRINTVAR=ELITEON
              CASE VALU='6'
                PRINTVAR=ELITEOFF
              CASE VALU='7'
               PRINTVAR=COMPRON
              CASE VALU='8'
               PRINTVAR=COMPROFF
             CASE VALU='E'
               EXIT
             OTHE
               LOOP
           ENDC
          IF CLIPPER
            IF ISPRINTER()
              SET CONS OFF
              SET PRIN ON
              ?&PRINTVAR          && Send printer control code
              SET PRIN OFF
              SET CONS ON
            ENDI
          ELSE
            SET CONS OFF
            SET PRIN ON
            ?&PRINTVAR            && Send printer control code
            SET PRIN OFF
            SET CONS ON
          ENDI
       ENDD
     OTHE
   ENDC
VALU=SPAC(20)
DO BLOCKCLR WITH RR,CC
RETU
*
PROC ASKL                         && Ask a logical question
PARA MLINE,MCOLUMN,MQUESTION,MANSWER
@ MLINE,MCOLUMN SAY SPAC(LEN(MQUESTION)+4)
STOR .F. TO MANSWER
@ MLINE,MCOLUMN SAY MQUESTION GET MANSWER PICT '@L '
READ
@ MLINE,MCOLUMN SAY SPAC(LEN(MQUESTION)+4)
RETU
*
PROC ASK2                         && Ask a multiple choice question
PARA MLINE,MCOLUMN,MQUESTION,MCHOICES,MANSWER
@ MLINE,MCOLUMN SAY SPAC(LEN(MQUESTION)+4)
STOR " " TO MANSWER
  DO WHIL .NOT. MANSWER $ MCHOICES
    @ MLINE,MCOLUMN SAY MQUESTION GET MANSWER PICT "@! "
    READ
  ENDD
@ MLINE,MCOLUMN SAY SPAC(LEN(MQUESTION)+4)
RETU
*
PROC BLOCKCLR                     && Clears a four line block
PARA RR,CC                        && on the screen.
@ RR,CC SAY SPAC(80)
@ RR+1,CC SAY SPAC(80)
@ RR+2,CC SAY SPAC(80)
@ RR+3,CC SAY SPAC(80)
@ RR+4,CC SAY SPAC(80)
RETU
*
PROC PRNTCODE                     && CONTAINS PRINTER CONTROL CODES
LQON='CHR(27)+"I"+"2"'            && CODES OF IBM PROPRINTER
LQOFF='CHR(27)+"I"+"0"'           && FOR NETWORK PRINTER 0
ELITEON='CHR(27)+":"'
ELITEOFF='CHR(27)+"I"+"0"'
COMPRON='CHR(15)'
COMPROFF='CHR(18)'
ENLGON='CHR(14)'
ENLGOFF='CHR(20)'
L1QON='CHR(27)+"x"+CHR(1)'
L1QOFF='CHR(27)+"x"+CHR(0)'
G1RAPHON='CHR(27)+CHR(109)+CHR(4)'   && CODES OF EPSON LX80
G1RAPHOFF='CHR(27)+CHR(109)+CHR(0)'  && FOR NETWORK PRINTER 1
E1LITEON='CHR(27)+"M"+CHR(15)'
E1LITEOFF='CHR(27)+"P"+CHR(18)'
C1OMPRON='CHR(27)+CHR(15)'
C1OMPROFF='CHR(27)+CHR(18)'
E1NLGON='CHR(27)'
E1NLGOFF='CHR(27)'
******************************************************************
* Add more printer control codes here for printers 2,3, and 4 if *
* you like.                                                      *
******************************************************************
RETU
*
PROCEDURE CNTR                    && Centers <Text> on <Line>
* Syntax:   DO CNTR WITH <Text>, [<Line>]
PARA Text,Line
IF CLIPPER
  IF Pcount()<2
    Line=0
  ENDIF
ENDI
@ Line,40-len(text)/2 SAY text
RETU

